import { RabbitSubscribe } from '@golevelup/nestjs-rabbitmq';
import { Inject } from '@nestjs/common';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import loggerOptions from '../logger.options';
import { level } from '../level.enum';

export class LoggerMessageHandler {
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {}

  @RabbitSubscribe({
    name: 'loggingLoggerHealthCrit',
  })
  public async loggerHealthCriticalHandler(message: string) {
    this.logger.configure(
      loggerOptions('logger', level.crit, 'critical', 'health'),
    );
    this.logger.crit(JSON.parse(message));
  }
}
