import { RabbitSubscribe } from '@golevelup/nestjs-rabbitmq';
import { Inject } from '@nestjs/common';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import { level } from '../level.enum';
import loggerOptions from '../logger.options';

export class MatcherMessageHandler {
  constructor(
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {}

  @RabbitSubscribe({
    name: 'loggingMatcherAdCrit',
  })
  public async matcherAdCriticalHandler(message: string) {
    this.logger.configure(
      loggerOptions('matcher', level.crit, 'critical', 'ad'),
    );
    this.logger.crit(JSON.parse(message));
  }

  @RabbitSubscribe({
    name: 'loggingMatcherMatchCrit',
  })
  public async matcherMatchCriticalHandler(message: string) {
    this.logger.configure(
      loggerOptions('matcher', level.crit, 'critical', 'match'),
    );
    this.logger.crit(JSON.parse(message));
  }
}
